<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2007 Lennart Reuther <lennart_reuther@web.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

require_once(PATH_tslib.'class.tslib_pibase.php');
require_once('class.tx_vtnt_db.php');
require_once('class.tx_vtnt_lib.php');

/**
 * Plugin 'vTnT' for the 'vtnt' extension.
 *
 * @author	Lennart Reuther <lennart_reuther@web.de>
 * @package	TYPO3
 * @subpackage	tx_lraysitemap
 */
class tx_vtnt_pi1 extends tslib_pibase {
	var $prefixId      = 'vtnt_pi1';		// Same as class name
	var $scriptRelPath = 'pi1/class.tx_vtnt_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey        = 'vtnt';	// The extension key.
	var $pi_checkCHash = true;
	
	var $conf;
	var $db;	// Datasource
	
	/**
	 * The main method of the PlugIn
	 *
	 * @param	string		$content: The PlugIn content
	 * @param	array		$conf: The PlugIn configuration
	 * @return	The content that is displayed on the website (Menu)
	 */
	function main($content,$conf)	{
		
		// Get the PID from which to make the menu.
			// If a page is set as reference in the 'Startingpoint' field, use that
			// Otherwise use the page's id-number from TSFE
		$menuPid = intval($this->cObj->data['pages']?$this->cObj->data['pages']:$GLOBALS['TSFE']->id);
	
			// Now, get an array with all the subpages to this pid:
			// (Function getMenu() is found in class.t3lib_page.php)
		$menuItems_level1 = $GLOBALS['TSFE']->sys_page->getMenu($menuPid);
	
		$this->conf= $conf;
		
		$this->db = t3lib_div::makeInstance('tx_vtnt_db');
		//$this->db = new tx_vtnt_db();
		
		$this->initJSLibraries();
		
		$this->db->setDebug(true);
		// $this->db->deleteAllUser();
		
		$GLOBALS['TSFE']->additionalHeaderData['tx_vtnt_inc'] = '
			<style type="text/css" id="tx_vtnt_inc_mapLayer"></style>
			<script type="text/javascript">
			//<![CDATA[
				//alert("javascript inserted");
			//]]>
			</script>
		';
		
		if ($this->piVars['noModules']!= 1) {
			$content = $this->tellWhatToDo('Click here if you want to know where to change the menu design');
		}
		else
		{
			$content = '<span><!-- script type="text/javascript"><![CDATA[$$("div.vtnt-pi1")[0].setAttribute("id","vtnt-pi1");alert("hallo");]]></script --></span>'."\n";
		}
		return $this->pi_wrapInBaseClass($content);
	}
	
	function myownwrap($str) {
		//$result = '<div class="boxTop"></div>';
		//$result .= '<div class="box">'.$str.'</div>';
		$result = $str;
		//$result .= '<div class="boxBot"></div>';
		return $result;
	}
	
	
	function pi_wrapInBaseClass($str)	{
		$content = '<div class="'.str_replace('_','-',$this->prefixId).'" id="'.str_replace('_','',$this->prefixId).'">'.$str.'</div>';
		$content = $this->myownwrap($content);
		
		if(!$GLOBALS['TSFE']->config['config']['disablePrefixComment'])	{
			$content = '
	<!--
		BEGIN: Content of extension "'.$this->extKey.'", plugin "'.$this->prefixId.'"
	-->
	'.$content.'
	<!-- END: Content of extension "'.$this->extKey.'", plugin "'.$this->prefixId.'" -->
	';
		}
		return $content;
	}
	
	
	
	
	/**
	 * Here you can do what ever you want
	 *
	 * @param	string		$str: The string that is processed
	 * @return	It's your decission
	 */
	function tellWhatToDo($str)	{
		//return '<a href="#" onClick="alert(\'Open the PHP-file '.t3lib_extMgm::siteRelPath('vtnt').'pi1/class.tx_vtnt_pi1.php and edit the function main()\nto change how the menu is rendered! It is pure PHP coding!\')">'.$str.'</a>';
		/*$filename = t3lib_extMgm::siteRelPath('vtnt').'pi1/template_vtnt.tmpl';
		$handle = fopen($filename,"r");
		$contents = fread($handle, filesize($filename));
        fclose($handle);*/
        
		$uId = $this->db->getUIdForSessionId($GLOBALS["TSFE"]->fe_user->id);
		
		if ($uId == "") {
			   $sessionId = $GLOBALS["TSFE"]->fe_user->id;
			    $pageId = $GLOBALS["TSFE"]->id;
			    
			    $GLOBALS["TSFE"]->fe_user->setKey("ses", "pid", $GLOBALS["TSFE"]->id);
			    $this->db->setVisitor($sessionId, $pageId); 
				$uId = $this->db->getUIdForSessionId($GLOBALS["TSFE"]->fe_user->id);
		}
		
		$user = $this->db->getSessionData($uId);
//		echo "<!-- userId ".$uId." - ".$user["id"]."-->";
        $contents .= '<div id="vTnT">'."\n";
      	//$contents .= '<div class="boxTop"></div>'."\n";
      	//$contents .= '<div class="box" style="width: 240px; height: 212px;">'."\n";
        //$contents .= '<div class="Rahmen" style="position: relative; ">'."\n";
        //$contents .= '<div class="boxTop"></div>'."\n";
        //$contents .= '<div class="box">'."\n";
        
       
        //$contents .= '<div id="vTnTVisualBorder">'."\n";
                
        $contents .= '<div id="vTnTVisual">'."\n";

        $contents .= '<script type="text/javascript">';
      	$contents .= '//<![CDATA['."\n";
		
      	$contents .= '  var myModel = new vTnTModel();'."\n";
      	$contents .= '  myModel.setPrefixId("'.$this->prefixId.'");'."\n";
      	$contents .= '  myModel.setPageId("'.$GLOBALS["TSFE"]->id.'");'."\n";
      	
      	$contents .= '  var myAvatar = new User();'."\n";
        $contents .= '  myAvatar.setX(Number('.$user["xpos"].'));'."\n";
        $contents .= '  myAvatar.setY(Number('.$user["ypos"].'));'."\n";    
        $contents .= '  myAvatar.setId(Number('.$uId.'));'."\n";
        $contents .= '  myAvatar.setName("'.$user["name"].'");'."\n";
        $contents .= '  myAvatar.setActive('.$user["chatter"].');'."\n";
        $contents .= '  myAvatar.setLoudness('.$user["loudness"].');'."\n";
        $contents .= '  myAvatar.setOwn(1);'."\n";
        $contents .= '  myAvatar.setNick("'.$user["nick"].'");'."\n";
        $contents .= '  myModel.updateUser(myAvatar,false);'."\n";
        $contents .= '  myModel.getUserDataFromServer();'."\n";
        $contents .= '  var cAktivUserExchange = new PeriodicalExecuter( function() { myModel.getUserDataFromServer();} , 15);'."\n";
        $contents .= '  var cTextLineExchange; '."\n";
/*        $contents .= '  myModel.setTextLineExchangeReference(cTextLineExchange);'."\n";*/
        
        $contents .= '  var cObserverNotify = new PeriodicalExecuter( function() { myModel.notifyObservers(myModel.oObjects2BeNotifiedFor);myModel.clearNotifierCache();} , 2);'."\n";
        
        $contents .= '  myModel.setIgnoreTextLines(false); '."\n";
        $contents .= ' var control = new VisualMap(myModel, "Nutzer-Control");'."\n";
        //$contents .= ' control.setWidth("420");'."\n";
        //$contents .= ' control.setHeight("350");'."\n";
        $contents .= ' control.setWidth("175");'."\n";
        $contents .= ' control.setHeight("220");'."\n";
        $contents .= ' control.setAttribute("onmousedown","control.getControl().grab(evt)");'."\n";
        $contents .= ' control.setAttribute("onmousemove","control.getControl().drag(evt)");'."\n";
        $contents .= ' control.setAttribute("onmouseup"  ,"control.getControl().drop(evt)");'."\n";
        $contents .= ' control.setAttribute("onmouseover","control.getControl().over(evt)");'."\n";
        $contents .= ' control.setAttribute("onmouseout" ,"control.getControl().out(evt)");'."\n";
  
		$contents .= $this->getVariablesOfTypo3();
        
        $contents .= ' // Reihenfolge beachten, da sonst avatare unter Produkten liegen koennten.'."\n"; 
        $contents .= ' var mapView = new MapView(myModel,"Landkarten-Metapher.");'."\n";
        $contents .= ' control.add(mapView);'."\n";

        $contents .= ' var avatarView = new AvatarView(myModel,"View mit den bunten Kreisen.");'."\n";
        $contents .= ' control.add(avatarView);';
        $contents .= ' document.getElementById("vTnTVisual").appendChild(control.paint());'."\n";    
        $contents .= ' var sliderView = new SliderView(myModel,"Zooming-Slider.", "sliderView");'."\n";
        $contents .= ' var textBoxView = new TextBoxView(myModel,"textBoxView");'."\n";
        $contents .= ' var textLineView = new TextLineView(myModel,"textLineView");'."\n";
        $contents .= ' var textLineControl = new TextLineControl(myModel, "TextLineControl", myModel.getOwnUser()[0]);'."\n";
        $contents .= ' textBoxView.setController(textLineControl);'."\n";
        $contents .= ' textBoxView.setView(textLineView);';
    
        $contents .= ' var ownAvatarIdView = new AvatarIdView(myModel, "ID-View", myModel.getOwnUser()[0]);'."\n";
        $contents .= '     ownAvatarIdView.setAction("ownAvatarIdControl.setProperties();");'."\n";
        $contents .= ' var ownAvatarIdControl = new AvatarIdControl(myModel, "ID-Control zur Anpassung der persoenlichen Daten", myModel.getOwnUser()[0]);'."\n";

        $contents .= ' var avatarDetailsView = new AvatarDetailsView(myModel, "haelt die Details zu Nutzern, welche per mouseOver ausgewaehlt wurden.");'."\n";
        $contents .= '//    var productDetailsView = new ProductDetailsView(myModel, "zeigt per MouseOver markierte Produkte im Detail an.");'."\n";
        $contents .= '//    productDetailsView.setProduct(myModel.oProducts[0]);'."\n";
        $contents .= ']]>'."\n";
        $contents .= '</script>'."\n";

        $contents .= '        <div id="vTnTAdmin">'."\n";
        $contents .= '           <div id="vTnTAdminMini">'."\n";
        $contents .= '         		<button id="vTnTInputFormInput15" name="input" title="open big admin-console" onclick="document.getElementById(\'vTnTAdminMain\').style.display = \'inline\';document.getElementById(\'vTnTAdminMini\').style.display = \'none\';$(\'vTnTAdmin\').setAttribute(\'class\',\'opened\');">+</button>'."\n";
        $contents .= '       	 </div>'."\n";        
        $contents .= '         	 <button id="vTnTInputFormInput14" name="input" title="go to maximized size" onclick="control.getControl().doWithUser(\'maxi\');">maxi</button>'."\n";       
        $contents .= '         	 <button id="vTnTInputFormInput18" name="input" title="go to portal-size" onclick="control.getControl().doWithUser(\'mini\');">mini</button>'."\n";	
        $contents .= '           <div id="vTnTAdminMain">'."\n";
        $contents .= '         		<button id="vTnTInputFormInput16" name="input" title="open big admin-console" onclick="document.getElementById(\'vTnTAdminMain\').style.display = \'none\';document.getElementById(\'vTnTAdminMini\').style.display = \'inline\';$(\'vTnTAdmin\').removeAttribute(\'class\');">-</button>'."\n"; 
        $contents .= '       	    <button id="vTnTInputFormInput2"  name="input" title="manually repings data from server" onclick="myModel.getUserDataFromServer();">Ping</button>'."\n";	
        $contents .= '       	    <button id="vTnTInputFormInput3"  name="input" title="manually checks for new messages" onclick="myModel.getTextDataFromServer();">CaD</button>'."\n";
        $contents .= '			 	<br />x1 <input type="text" size="3" name="x1value" id="x1value" /> y1 <input type="text" size="3" name="y1value" id="y1value" /> x2 <input type="text" size="3" name="x2value" id="x2value" /> y2 <input type="text" size="3" name="y2value" id="y2value" /> zoom <input type="text" size="3" name="zoomvalue" id="zoomvalue" />'."\n";
        $contents .= '       	 	<button id="vTnTInputFormInput1"  name="input" title="loadProducts" onclick="myModel.getProductsFromServer(document.getElementById(\'x1value\').value,document.getElementById(\'y1value\').value,document.getElementById(\'x2value\').value,document.getElementById(\'y2value\').value, document.getElementById(\'zoomvalue\').value);">getProducts</button>'."\n";
        $contents .= '       	 	<button id="vTnTInputFormInput17"  name="input" title="loadAllProducts" onclick="myModel.getProductsFromServer(0,0,2000,2000);">getAllProducts</button>'."\n";
        $contents .= '         		<button id="vTnTInputFormInput10" name="input" title="stop user-ajax" onclick="cAktivUserExchange.stop();">stop user-update</button>'."\n";	
        $contents .= '         		<button id="vTnTInputFormInput11" name="input" title="stop text-update" onclick="cTextLineExchange.stop();">stop text-update</button>'."\n";
        $contents .= '       	</div><script type="text/javascript">document.getElementById(\'vTnTAdminMain\').style.display = "none";document.getElementById(\'vTnTAdminMini\').style.display = "inline";</script>'."\n";
        $contents .= '       </div>'."\n";
        $contents .= '    </div> <!-- vTNT-Visual -->'."\n";        
       // $contents .= '	  <div style="clear:both"></div>';
       // $contents .= '    </div> <!-- vTnTVisualBorder -->'."\n";      
        
        
        // $contents .= '    </div><div class="boxBot"></div></div>'."\n";
        
        $contents .= '  <s:svg xmlns:s="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink"'."\n";
        $contents .= '    onload="sliderView.getControl().getSVGDoc(evt)" id="vTnTSlider" '."\n";
        $contents .= '    style="z-index: 11000;display: none;position:absolute;"'."\n";
        $contents .= '    viewBox="0 0 170 20"'."\n";
        $contents .= '    width="170" height="20">'."\n";
  
        $contents .= '    <s:title>SVG</s:title>'."\n";
        $contents .= '    <s:desc>SVG-Spezifikation in Beispielen</s:desc>'."\n";
        $contents .= '  </s:svg>'."\n";

        $contents .= '        <script type="text/javascript">'."\n";
        $contents .= '    //<![CDATA['."\n";
        $contents .= '            $("vTnT").appendChild(textBoxView.paint());'."\n";
        $contents .= '            $("vTnT").appendChild(ownAvatarIdView.paint());'."\n";
        $contents .= '            sliderView.getControl().setStartX(145);'."\n";        
        $contents .= '            $("vTnTSlider").appendChild(sliderView.paint());'."\n";
        $contents .= '            sliderView.getControl().init();'."\n";
          $contents .= '            myModel.setViewMode(0);'."\n";
        $contents .= '            control.getControl().doWithUser("mini");'."\n";
        $contents .= '            $("vTnT").appendChild(avatarDetailsView.paint());'."\n";
        $contents .= '            //$("vTnT").appendChild(productDetailsView.paint());'."\n";          
          

        $contents .= '          //Mausrad ansteuern'."\n";
        $contents .= '          /** Initialization code.'."\n"; 
        $contents .= '           * If you use your own event management code, change it as required.'."\n";
        $contents .= '           */'."\n";          
        $contents .= '          if (document.getElementById("vTnTVisual").addEventListener)'."\n";
        $contents .= '                  document.getElementById("vTnTVisual").addEventListener("DOMMouseScroll", sliderView.getControl().wheel, false);'."\n";

        $contents .= '          /** IE/Opera. */'."\n";
        $contents .= '          window.onmousewheel = document.getElementById("vTnTVisual").onmousewheel = sliderView.getControl().wheel;'."\n";

        $contents .= '           myModel.getProductsFromServer(0,0,1000,1000, true);'."\n";
        
        //$contents .= '  $$("div.vtnt-pi1")[0].setAttribute("id","vtnt-pi1");'."\n";

        $contents .= "  	    new Draggable('vTnTChat');\n";
        $contents .= "  	    new Draggable('vTnTIdControl');\n";
       // $contents .= '  	    
      //  						if (document.getElementById("vTnTVisual").className == "minimized") {';
	//	$contents .= "  	       new Draggable('vTnTVisual'); } \n";				
        
        $contents .= ']]>'."\n";
        $contents .= '       </script>'."\n"; 
        $contents .= '</div>'."\n";
        $contents .= '<!-- Part, that does the background -->'."\n";
        $contents .= '<div id="vTnTBackground" onclick="control.getControl().doWithUser(\'mini\');" style="display: none; position: absolute; top:0px; left:0px; background-color:#000000; opacity: 0.8;"> </div>'."\n";
                    
        return $contents;
        //$filename)." size ".$filename;
	}
	
	/**
	 * Initializes needed JS-Libraries like Prototype, Scriptaculous, etc...
	 */
	function initJSLibraries() {
		// only include prototype if not used prototypejs
		
		if ($this->piVars['noModules']!= 2) {
			if($this->db->extCONF['prototypeJSPath'] && !t3lib_extMgm::isLoaded('prototypejs'))
				$GLOBALS['TSFE']->additionalHeaderData['tx_vtnt_inc_chat'] .= '
				<script type="text/javascript" src="'.$this->db->extCONF['prototypeJSPath'].'"></script>
				'; else $GLOBALS['TSFE']->additionalHeaderData['tx_vtnt_inc_chat'] .=
				   		'<script type="text/javascript" src="'.t3lib_extMgm::siteRelPath($this->extKey).'pi1/js/lib/prototype.js"></script>';
							
	
			if($this->db->extCONF['scriptaculousJSPath'])
				$GLOBALS['TSFE']->additionalHeaderData['tx_vtnt_inc_chat'] .= '
				<script type="text/javascript" src="'.$this->db->extCONF['scriptaculousJSPath'].'"></script>
			';
			
			$GLOBALS['TSFE']->additionalHeaderData['tx_vtnt_inc_chat'] .= '
	   		<!--<script type="text/javascript" src="'.t3lib_extMgm::siteRelPath($this->extKey).'pi1/js/lib/md5.js" 				></script>-->
	    	<script type="text/javascript" src="'.t3lib_extMgm::siteRelPath($this->extKey).'pi1/js/lib/log4js.js"  				></script>
	    	<script type="text/javascript" src="'.t3lib_extMgm::siteRelPath($this->extKey).'pi1/js/effects.js"			        ></script>    	
	    	<script type="text/javascript" src="'.t3lib_extMgm::siteRelPath($this->extKey).'pi1/js/func.extScriptalicious.js"   ></script>    
	    	<script type="text/javascript" src="'.t3lib_extMgm::siteRelPath($this->extKey).'pi1/js/dragdrop.js"   			></script>    
	    	<script type="text/javascript" src="'.t3lib_extMgm::siteRelPath($this->extKey).'pi1/js/class.User.js"               ></script>
		    <script type="text/javascript" src="'.t3lib_extMgm::siteRelPath($this->extKey).'pi1/js/class.Product.js"            ></script>
		    <script type="text/javascript" src="'.t3lib_extMgm::siteRelPath($this->extKey).'pi1/js/class.ProductDetailsView.js" ></script>
		    <script type="text/javascript" src="'.t3lib_extMgm::siteRelPath($this->extKey).'pi1/js/class.Observable.js"         ></script>
		    <script type="text/javascript" src="'.t3lib_extMgm::siteRelPath($this->extKey).'pi1/js/class.AvatarAsDecorator.js"  ></script>
		    <script type="text/javascript" src="'.t3lib_extMgm::siteRelPath($this->extKey).'pi1/js/class.vTnTModel.js"          ></script>
		    <script type="text/javascript" src="'.t3lib_extMgm::siteRelPath($this->extKey).'pi1/js/class.AvatarControl.js"      ></script>
		    <script type="text/javascript" src="'.t3lib_extMgm::siteRelPath($this->extKey).'pi1/js/class.AvatarView.js"         ></script>    
		    <script type="text/javascript" src="'.t3lib_extMgm::siteRelPath($this->extKey).'pi1/js/class.AvatarDetailsView.js"  ></script>
		    <script type="text/javascript" src="'.t3lib_extMgm::siteRelPath($this->extKey).'pi1/js/class.AvatarIdControl.js"    ></script>
		    <script type="text/javascript" src="'.t3lib_extMgm::siteRelPath($this->extKey).'pi1/js/class.AvatarIdView.js"       ></script>
		    <script type="text/javascript" src="'.t3lib_extMgm::siteRelPath($this->extKey).'pi1/js/class.MapView.js"            ></script>
		    <script type="text/javascript" src="'.t3lib_extMgm::siteRelPath($this->extKey).'pi1/js/class.SliderView.js"         ></script>
		    <script type="text/javascript" src="'.t3lib_extMgm::siteRelPath($this->extKey).'pi1/js/class.SliderControl.js"      ></script>
		    <script type="text/javascript" src="'.t3lib_extMgm::siteRelPath($this->extKey).'pi1/js/class.VisualMap.js"          ></script>    
		    <script type="text/javascript" src="'.t3lib_extMgm::siteRelPath($this->extKey).'pi1/js/class.TextBoxView.js"        ></script>
		    <script type="text/javascript" src="'.t3lib_extMgm::siteRelPath($this->extKey).'pi1/js/class.TextLineDecorator.js"  ></script>
		    <script type="text/javascript" src="'.t3lib_extMgm::siteRelPath($this->extKey).'pi1/js/class.TextLine.js"           ></script>
		    <script type="text/javascript" src="'.t3lib_extMgm::siteRelPath($this->extKey).'pi1/js/class.TextLineControl.js"    ></script>
		    <script type="text/javascript" src="'.t3lib_extMgm::siteRelPath($this->extKey).'pi1/js/class.TextLineView.js"       ></script>    
		    <script type="text/javascript" src="'.t3lib_extMgm::siteRelPath($this->extKey).'pi1/js/func.extScriptalicious.js"   ></script>    
	    	<script type="text/javascript" src="'.t3lib_extMgm::siteRelPath($this->extKey).'pi1/js/func.initialize.js"			></script>    	
	    	<script type="text/javascript" src="'.t3lib_extMgm::siteRelPath($this->extKey).'pi1/js/func.ajax.js"			    ></script>    	
	    	';
		};
		
	}

	/**
	 * identifying the user and the site he is on.
	 * 
	 * This function identifies the Session-ID used internally in typo3
	 * and the actual pid of the site being visited.
	 * 
	 * Both is being written into the tx_vtnt_sessions - table with imaginary
	 * coordinates corresponding with the product being viewed.               	 
	 *
	 * @author: LER
	 * @return	It's your decission
	 */
	function identUser()	{

    //$db = new tx_vtnt_db();
    $db = t3lib_div::makeInstance('tx_vtnt_db');
    $sessionId = $GLOBALS["TSFE"]->fe_user->id;
    $pageId = $GLOBALS["TSFE"]->id;
    
    $GLOBALS["TSFE"]->fe_user->setKey("ses", "pid", $GLOBALS["TSFE"]->id);
    $db->setVisitor($sessionId, $pageId); 
    echo "user-ID".$GLOBALS["TSFE"]->id;
	}

	/**
	 * return all Variables set in Typo3 as String into the source-code
	 */
	function getVariablesOfTypo3() {
		$contents = "";
		
		// Part with Constants
      	if (strtoupper($this->conf['xResizingPosition']) == "LEFT") {
	      	$contents .= 'control.getControl()._X_RESIZING_POSITION_ = "left"'."\n";
      	}  elseif (strtoupper($this->conf['xResizingPosition']) == "RIGHT") {
  			$contents .= 'control.getControl()._X_RESIZING_POSITION_ = "right"'."\n";
      	};
		
		// Part with Constants
      	if (strtoupper($this->conf['yResizingPosition']) == "TOP")
	      	$contents .= 'control.getControl()._Y_RESIZING_POSITION_ = "top"'."\n";
	    elseif (strtoupper($this->conf['yResizingPosition']) == "BOTTOM")
  			$contents .= 'control.getControl()._Y_RESIZING_POSITION_ = "bottom"'."\n";

  			
  			
  			return $contents;
	}
	
	

}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/vtnt/pi1/class.tx_vtnt_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/vtnt/pi1/class.tx_vtnt_pi1.php']);
}

?>
