/**
 * class AvatarIdView
 *   
 * Der View stellt die Daten des Models am Bildschirm dar. Er ermglicht
 * also die Sicht auf das Model und reagiert auf nderungen im Model. 
 * 
 * @author lray
 * @version 2007-02-16
 */    

  var AvatarDetailsView = Class.create();

  AvatarDetailsView.prototype = {

    oModel: Object(),
    oLogger:Object(),  
    sName: String("AvatarDetailsView"),
    oUser: Object(),
    oVTnTAvatarDetails: Object(),
    oMyImage: Object(),
    
    aElements: Array(),
    

  /**
   * Initialisiert Model und View.
   * @param oMap zum Controller gehoeriger View
   * @param m Mathematisches Modell
   */
    initialize: function( oModel, sName )
    {
      this.oLogger = new Log4js.getLogger("vtntTest");

      if (oModel instanceof vTnTModel) {
        this.oModel = oModel;
        this.oModel.addObserver(this);      

      } else this.oLogger.warn("AvatarIdView.initialize: Modell oder View nicht bergeben, laufe im Leerlauf!")
      
      if (sName != null) this.sName = sName;
      
      this.oUser = new User();

      this.aElements = new Array(
        new Array("nickInput","Nickname"), 
        new Array("nameInput","Name"), 
        new Array("companyInput","Firma"),
        new Array("positionInput","Position"),
        new Array("mailInput","E-Mail")
        );

      this.generateSource();      

    },

    notify: function(m, o) {
     if( this.oModel == m) { 
        if (o.detailedUser instanceof User) {
            this.update(o.detailedUser);
        }
        else 
          this.clearUser();
        } 
     else this.oLogger.debug("AvatarIdView.notify: Object ("+typeof(o)+") Array:"+(o instanceof Array));   
    },


    update: function(oUser) {
        this.oUser = oUser;
        this.oLogger.debug("AvatarDetailsView.update: keine Aenderung ");
        this.fillUserDetails();
    },

    clearUser: function() {
      this.oVTnTAvatarDetails.setAttribute("style","display:none;");
    },

    paint: function() {
      return this.oVTnTAvatarDetails;
    },

    toString: function()
    {
      return this.sName;
    },
  
  /* --------------------------------------------------*/
  // handleEvent-Methode
    setAction: function(sAction) {
      this.oVTnTAvatarDetails.setAttribute('action','javascript:'+sAction);
    },

        /**
         * generateSource
         * 
         * erzeugt die zur Darstellung bentigte XML-Struktur.
         * 
         * @author lray
         * @version 2007-03-30                                             
         */      
        generateSource: function() {
            this.oVTnTAvatarDetails = document.createElementNS(xhtmlNS,'div');
            this.oVTnTAvatarDetails.setAttribute('id','AvatarDetails');
            this.oVTnTAvatarDetails.setAttribute('class','ava_details');           
            
            var oVTnTAvatarDL = document.createElementNS(xhtmlNS,'dl');                     
            var detailData = new Array( "Name","Nick","Company","Position","Pic");
                   
            for (var i=0; i<4; i++){
              var oNewAvatarDetailsNode = document.createElementNS(xhtmlNS,'dt');
              var oNewAvatarDetailsNode2 = document.createElementNS(xhtmlNS,'dd');              
              var oNewAvatarDetailsTextNode = document.createTextNode(detailData[i]);             
              this.aElements[i] = document.createTextNode("tst");
              oNewAvatarDetailsNode.appendChild(oNewAvatarDetailsTextNode);
              oNewAvatarDetailsNode2.appendChild(this.aElements[i]);
              oVTnTAvatarDL.appendChild(oNewAvatarDetailsNode);
              oVTnTAvatarDL.appendChild(oNewAvatarDetailsNode2);              
            };

            var oNewAvatarDetailsNode = document.createElementNS(xhtmlNS,'dt');
            var oNewAvatarDetailsNode2 = document.createElementNS(xhtmlNS,'dd');
            var oNewAvatarDetailsTextNode = document.createTextNode(detailData[4]);             
            oNewAvatarDetailsNode.appendChild(oNewAvatarDetailsTextNode);
            this.oMyImage = document.createElementNS(xhtmlNS,"img");
            this.aElements[4] = document.createTextNode("tst");
            this.oMyImage.setAttribute("src",this.aElements[4]);
            this.oMyImage.setAttribute("width",80);
            this.oMyImage.setAttribute("height",80);
            oNewAvatarDetailsNode2.appendChild(this.oMyImage);
            oVTnTAvatarDL.appendChild(oNewAvatarDetailsNode);
            oVTnTAvatarDL.appendChild(oNewAvatarDetailsNode2);              
            this.oVTnTAvatarDetails.appendChild(oVTnTAvatarDL);
            
            this.fillUserDetails();
        },    

     fillUserDetails: function() {
          this.aElements[0].data = this.oUser.getName();
          this.aElements[1].data = this.oUser.getNick();
          this.aElements[2].data = this.oUser.getCompany();
          this.aElements[3].data = this.oUser.getPositionName();
          this.aElements[4].data = this.oUser.getPicUrl();
          this.oMyImage.setAttribute("src",this.aElements[4].data);
          
          this.oVTnTAvatarDetails.setAttribute('style','display:block;position:absolute;left:'
            +(this.oModel.viewPortX(this.oUser.getX())+110)+'px;top:'
            +(this.oModel.viewPortY(this.oUser.getY())+20)+'px;');
     } 

}
