/**
 * class AvatarIdView
 *   
 * Der View stellt die Daten des Models am Bildschirm dar. Er ermglicht
 * also die Sicht auf das Model und reagiert auf nderungen im Model. 
 * 
 * @author lray
 * @version 2007-02-16
 */    

  var AvatarIdView = Class.create();

  AvatarIdView.prototype = {

    oModel: Object(),
    oLogger:Object(),  
    sName: String("AvatarIdView"),
    oUser: Object(),
    oVTnTIdControl: Object(),
    oVTnTIdImage: Object(),
    
    aElements: Array(),
    

  /**
   * Initialisiert Model und View.
   * @param oMap zum Controller gehoeriger View
   * @param m Mathematisches Modell
   */
    initialize: function( oModel, sName, oUser )
    {
      this.oLogger = new Log4js.getLogger("vtntTest");

      if (oModel instanceof vTnTModel) {
        this.oModel = oModel;
        this.oModel.addObserver(this);      

      } else this.oLogger.warn("AvatarIdView.initialize: Modell oder View nicht bergeben, laufe im Leerlauf!")
      
      if (sName != null) this.sName = sName;
      
      if (oUser instanceof User) {
        this.oUser = oUser;
      } else this.oLogger.warn("AvatarIdView.initialize: User-Object nicht bergeben, laufe im Leerlauf!")

      this.aElements = new Array(
        new Array("nickInput","Nickname"), 
        new Array("nameInput","Name"), 
        new Array("companyInput","Firma"),
        new Array("positionInput","Position"),
        new Array("mailInput","E-Mail")
        );

      this.generateSource();      

    },

    notify: function(m, o) {
     if( this.oModel == m && (o.user instanceof Array)) { 
        
        if ((o.user instanceof Array) && (o.user.length > 0)) {
	        for (var i=0; i< o.user.length; i++)
	          if (o.user[i] == this.oUser.getId()) {
	            this.update();
	        }
        }
        else this.oLogger.debug("AvatarIdView.notify: keine passenden Notifies (array-site "+o["user"].length+")");
     } 
     else this.oLogger.debug("AvatarIdView.notify: Object ("+typeof(o)+") Array:"+(o instanceof Array));   
    },


    update: function() {
        this.oLogger.warn("AvatarIdView.notify: updating User ");
        $("nickInput").value    = this.oUser.getNick(); 
        $("nameInput").value    = this.oUser.getName();
        $("companyInput").value = this.oUser.getCompany();
        $("positionInput").value= this.oUser.getPositionName();
        $("mailInput").value    = this.oUser.getEmail();
        $("personalitiesPicture").setAttribute('src',this.oUser.getPicUrl(),1);
        return;
    },

    paint: function() {
      return this.oVTnTIdControl;
    },

    toString: function()
    {
      return this.sName;
    },
  
  /* --------------------------------------------------*/
  // handleEvent-Methode
    setAction: function(sAction) {
      this.oVTnTIdControl.setAttribute('action','javascript:'+sAction);
    },

        /**
         * generateSource
         * 
         * erzeugt die zur Darstellung bentigte XML-Struktur.
         * 
         * @author lray
         * @version 2007-03-30                                             
         */      
        generateSource: function() {
            this.oVTnTIdControl = document.createElementNS(xhtmlNS,'form');
            this.oVTnTIdControl.setAttribute('action', 'javascript:alert(\'Insert updateUserDetails here\');');
            this.oVTnTIdControl.setAttribute('id','vTnTIdControl');
            
            var oVTnTFieldset = document.createElement('fieldset');
            oVTnTFieldset.setAttribute('id','vTnTPersonalities');


            this.oVTnTIdImage = document.createElement('img');
//            this.oVTnTIdControl.appendChild(this.oVTnTIdImage);
            this.oVTnTIdControl.appendChild(oVTnTFieldset);
            
            this.oVTnTIdImage.setAttribute('id', 'personalitiesPicture');
            this.oVTnTIdImage.setAttribute('width','80');
            this.oVTnTIdImage.setAttribute('height','80');
           
            var oVTnTLegend = document.createElement('legend');
            oVTnTLegend.appendChild(document.createTextNode('Personalien'));
            oVTnTFieldset.appendChild(oVTnTLegend);          
            oVTnTFieldset.appendChild(this.oVTnTIdImage);

            for (var i=0; i < this.aElements.length; ++i)
            {
              var tmpLabel = document.createElement('label');
              tmpLabel.setAttribute('for',this.aElements[i][0]);
              tmpLabel.setAttribute('id',this.aElements[i][0]+"Label");
              tmpLabel.appendChild(document.createTextNode(this.aElements[i][1]));
              var tmpInput = document.createElement('input');
              tmpInput.setAttribute('type','text');
              tmpInput.setAttribute('id',this.aElements[i][0]);
              oVTnTFieldset.appendChild(tmpLabel);
              oVTnTFieldset.appendChild(tmpInput);              
            } 

              var tmpInput = document.createElement('input');
              tmpInput.setAttribute('type','submit');
              tmpInput.setAttribute('value','okay');
              oVTnTFieldset.appendChild(tmpInput);
        },    


}
