/**
 * Class Observable
 * 
 * @author lray
 * @version 2007-02-21
 */   
  var Observable = Class.create();
  Observable.prototype = {
    elements: Array(),
    bChanged: Boolean(),
    oLogger: Object(),
    sName: String(),
    aChanged: Array(),

   /**
    * Nimmt Observer in Liste auf
    * @param Object Observer-Objekt
    * @author lray
    * @version 2007-02-16
    */                  
   addObserver: function(obs) {
      this.elements.push(obs);
      this.oLogger.debug("vTnTModel.addObserver("+this.elements.length+"): "+obs.toString());
    }, 

    /**
     * Lscht Observer aus der Liste
     * @param Object zu entfernender Observer
     * @author lray
     * @version 2007-02-16
     */                         
   deleteObserver: function(obs) {
      this.elements.splice(this.elements.indexOf(obs),1);
      this.oLogger.debug("Observer: removed "+obs.toString());
    },

    /**
     * Lscht alle Observer aus der Liste
     * @author lray
     * @version 2007-02-16
     */                         
   deleteObservers: function() {
      this.elements.clear();
    },
    
    /**
     * Benachrichtigt bestimmten Observer ber nderungen
     * @param Object zu benachrichtigender Observer
     * @author lray
     * @version 2007-02-16
     */                         
   notifyObserver: function(obs,reason) {
    if (reason == null) reason = this.aChanged;
    obs.notify(this, reason);
    this.aChanged = Array();
    },

   /**
    * Benachrichtigt alle Observer ber nderungen
    * @author lray
    * @version 2007-02-16
    */                
   notifyObservers: function(reason) {
    this.bChanged = false;
    if (reason == null)
      reason = this.aChanged;
    
    for (var i=0; i < this.elements.length; ++i) { 
       this.elements[i].notify(this, reason);
       this.oLogger.debug("notify updating:"+this.elements[i].toString());
       }
    this.aChanged = Array();
    reason = null;
    },

   /**
    * setzt nderungs-Flag
    * @author lray
    * @version 2007-02-16
    */               
   setChanged: function() {
      this.bChanged = true;
    },
    
   toString: function() {
    return this.sName;
   } 
  
  }
// JavaScript Document
