/** 
 * Objekt Product
 * 
 * verwaltet die Eigenschaften eines Produktes
 * 
 * @author lray
 * @version 2007-02-15
 */       

  var Product = Class.create();
  Product.prototype = {
    
    oLogger:Object(),   
    sID:String(),
	iPId: Number(0),
  	sName:String(),
    sShortDesc: String(),
    sDescription: String(),
    sPicUrl: String(),
    sLinkUrl: String(),
    iX: Number(0),
    iY: Number(0),
    iWidth: Number(80),
    iHeight: Number(80),
    iLayer: Number(0),
    oNodeContent: Object(), 
    myNode: Object(),
    myNode1: Object(),
    myPicNode: Object(),
    myTextNode: Object(),
    elements: Array(),
    __XOFFSET__: Number(0),
    __YOFFSET__:Number(0),
   

    initialize: function() {
         //open maingroup
      this.oLogger = new Log4js.getLogger("vtntTest");
      this.oLogger.debug("Product initiated");
      this.dLastMoved = 0;
      this.elements = new Array();
      this.myNode = new Object(),
      this.myPicNode = new Object();      
      this.myNode = document.createElementNS(svgNS,"g");
      this.myNode1 = document.createElementNS(svgNS,"g");
      this.myNode1.setAttribute("x", 0);
      this.myNode1.setAttribute("y", 0);

      this.myNode.appendChild(this.myNode1);
      this.oNodeContent = document.createElementNS(svgNS,'g');

      this.myTextNode = document.createElementNS(svgNS,"text");
      this.myNode1.appendChild(this.myTextNode);
      
      this.setX(0);
      this.setY(0);
      this.setWidth(2000);
      this.setLayer(0);
      this.setHeight(2000);
      this.setId(0);
		
    },

    notify: function() {
      this.oLogger.warn("Class "+this.getId()+" notified, but not yet implemented.");
    },

    remove: function() {
    // @todo: fill it
    },

  	setName: function(name) {
      this.oLogger.info("Product.setName: "+this.getId()+" set to "+name);
      this.sName = name;
      
      var childNodes = this.myTextNode.childNodes;
      var i = childNodes.length;
      
      // delete all existing Name-Texts
      while (i > 0) {
      	this.myTextNode.removeChild(childNodes[i]);
      	i = childNodes.length;
      }

      this.myTextNode.appendChild(document.createTextNode(String(this.getName())));
      this.myTextNode.setAttribute('id','txt'+String(this.getName())+Math.floor(Math.random()*100));
      this.myTextNode.setAttribute('class','prod_txt');
      this.oLogger.info("Product.setName done");
      
    },
    
  	getName: function() {return this.sName;},
  	
  	toString: function() {return this.sName;},

  	setDescription: function(name) {
      this.sDescription = name;
    },
  	getDescription: function() {return this.sDescription;},

  	setShortDesc: function(item) {
      this.sShortDesc = item;
    },
  	getShortDesc: function() {return this.sShortDesc;},

  	/**
  	* Sets the URL to a given Image and adds it to the document-tree
  	*
  	*/
  	setPicUrl: function(picUrl) {
      this.oLogger.info("Product.setPicURL: "+this.getId()+" set to "+picUrl);
      this.sPicUrl = picUrl;
      
      if (this.getPicUrl() != null && this.getPicUrl()!="") {
        
       	this.myPicNode = document.createElementNS(svgNS,"image");
       	this.myNode1.appendChild(this.myPicNode);
        
        this.myPicNode.setAttributeNS(xlinkNS,'href',this.getPicUrl());
        this.myPicNode.setAttribute('id',"prim_"+this.getId());
        this.myPicNode.setAttribute('class','prod_image');
        this.myPicNode.setAttribute('x','0');
        this.myPicNode.setAttribute('y','0');
        this.myPicNode.setAttribute('width',this.getWidth());
        this.myPicNode.setAttribute('height',this.getHeight());                               

       }
      
    },
  	getPicUrl: function() {return this.sPicUrl;},

  	setLinkUrl: function(linkUrl) {
      this.oLogger.debug("Product.setLinkURL: "+this.getId()+" set to "+linkUrl);
      this.sLinkUrl = linkUrl;
    },
  	getLinkUrl: function() {return this.sLinkUrl;},

  	setId: function(id) {
      this.oLogger.info("Product.setId: from "+this.sID+" to "+id);
      this.sID = id;
      this.myNode1.setAttribute("id", "prod_"+((this.getId()!="")?this.getId():Math.floor(Math.random()*1000)));
    },
  	getId: function() {return this.sID;},  

  	setPId: function(id) {
      this.iPId = id;
      this.oLogger.info("Product.setPId: "+id);
    },
  	getPId: function() {return this.iPId;},  

  	setX: function(id) {
      this.iX = Number(id);
      this.myNode.setAttribute("transform", "translate("+String(this.getX())+","+String(this.getY())+")");
    },
  	getX: function() {return this.iX;},  

  	setY: function(id) {
      this.iY = Number(id);
      this.myNode.setAttribute("transform", "translate("+String(this.getX())+","+String(this.getY())+")");
    },
  	getY: function() {return this.iY;},
  	
  	setWidth: function(id) {     
      this.iWidth = Number(id);
      this.myNode1.setAttribute("width", this.getWidth());
      this.myTextNode.setAttribute('x',Math.floor(this.getWidth()/2));
      this.myTextNode.setAttribute('width',this.getWidth());      

    },

  	getWidth: function() {
      return this.iWidth;
    },  

 	setLayer: function(layer) {     
      this.iLayer = Number(layer);
      this.myNode1.setAttribute('class','prod_body mapLayer'+this.getLayer());     
      this.oLogger.info("product"+this.getId()+" Layer set to "+this.getLayer());
      
      for (var i=0; i < this.elements.length; i++) {
      	this.elements[i].setLayer(this.getLayer()+1);
      }
    },

  	getLayer: function() {
      return this.iLayer;
    },  

  	setHeight: function(id) {
      this.iHeight = Number(id);
      this.myNode1.setAttribute("height", this.getHeight());     
      this.myTextNode.setAttribute('y',Math.floor((this.getHeight()/2)));

    },

  	getHeight: function() {
      return this.iHeight;
    },

    setNodeContent: function(oContent) {
      this.oLogger.info("Product.setNodeContent: to "+oContent);
      try {
        this.myNode1.removeChild(this.oNodeContent);
        } catch (e) {
        }
      this.oNodeContent = oContent;
      try {
        this.myNode1.appendChild(this.oNodeContent);
        } catch (e) {
          this.oLogger.warn("Product.paint - no nodeContent "+this.oNodeContent+" with type "+typeof this.oNodeContent+"!("+e+")");
        }
    },
    
    getNodeContent: function() {
      return this.oNodeContent;
    }, 
    
    touchX: function(x1, x2) {
      var fstIn = false;
      var sndIn = false;

      if ((x1 >= this.getX()) 
      && (x1 <= this.getX()+this.getWidth()))
       fstIn = true;   

      if ((x2 >= this.getX()) 
      && (x2 <= this.getX()+this.getWidth()))
       sndIn = true;
      
      this.oLogger.debug("touchX got x1:"+x1+",x2:"+x2
          +" to own x1:"+this.getX()+","+Number(this.getX()+this.getWidth())
          +" and thinks "+(fstIn||sndIn));

      return fstIn||sndIn;
    },
   
    touchY: function(y1, y2) {
      var fstIn = false;
      var sndIn = false;

      if ((y1 - this.getY() >0) 
      && (y1 - this.getY() < this.getHeight())
      ) fstIn = true;   

      if ((y2 - this.getY() >0) 
      && (y2 - this.getY() < this.getHeight())
      ) sndIn = true;
      
      this.oLogger.debug("touchY got y1:"+y1+",y2:"+y2
          +" to own y1:"+this.getY()+","+Number(this.getY()+this.getHeight())
          +" and thinks "+(fstIn||sndIn));
      return fstIn||sndIn;
    },
    
    addItem: function(oProduct) {
      try {
      	oProduct.setLayer(this.getLayer()+1);
      } catch (e) {};
      this.elements.push(oProduct);
      this.oLogger.info("added "+oProduct.getId()+" zu "+this.getId()
          +"\n now holding Elements:"+this.elements.length );
	  oProduct.setLayer(this.iLayer+1);
	  
	   if (oProduct != this && oProduct != null) {
          this.myNode.appendChild(oProduct.paint());
          this.oLogger.debug("ProductCatgory.paint "+oProduct.getId()+" to "+this.getId());
	    }
      },
      
     updateProductTree: function() {
     	for (var i = 0; i < this.elements.length; i++) {
     		if (this.elements[i].getPId() != this.getId()) {
     			var tmpProduct = this.getProduct(this.elements[i].getPId());
     			if (tmpProduct != null) {
     				tmpProduct.addItem(this.elements[i]);
     				this.elements.splice(i,1);
     				i--;
     			}
     		}
     	}
     },
      
    _each: function(iterator) {
        for (var i = 0; i < this.elements.length; i++)
          iterator(this.elements[i]);
    },  

    calculateSize: function() {
    
    },
       
    toString: function() {
      return this.getId();
    },
    
    /**
     * Suche nach Produkt-Id rekursiv.
     * Falls ich selbst die gesuchter ID bin, "returne" this.
     * Durchsuche alle angehngten ID und rekursiv deren Unter-IDs.                
     **/         
    getProduct: function(sProductId) {

      if (this.getId() == sProductId) {return this;}      
      
      for (var i = 0; i < this.elements.length; i++) {

        if (this.elements[i].getId() == sProductId) {
          return this.elements[i];
        }
        
        var myDummyObject = this.elements[i].getProduct(sProductId);
        if (myDummyObject != null) return myDummyObject;
      };
      return null; 
    },
    
     /**
     * getProductOnPosition
     *
     * Suche nach Produkt-Id rekursiv.
     * Falls ich selbst die gesuchter ID bin, "returne" this.
     * Durchsuche alle angehngten ID und rekursiv deren Unter-IDs.                
     **/         
    getProductOnPosition: function(iX, iY, fZoom) {

      var searchedProduct = null; //ich wei noch nicht, welche die gesuchte Seite ist.

      /*alert("found coordinates "+iX+"/"+iY
      		+"for product "+this.getX()+"/"+this.getY()
      		+" with width/height "+this.getWidth()+"/"+this.getHeight());*/
		//&& this.elements.length != 0 
      
      //Melde die Position und Mae jeder Seite, die mit dieser Funktion aufgerufen wird
      //alert(this.getName() + ": x=" + this.getX() + ", y=" + this.getY()+ ", w=" + this.getWidth()+ ", h=" + this.getHeight());
      
      if ( 
      	(this.getWidth()==0 && this.getHeight()==0)
      	|| (iX >= this.getX() && iY >=this.getY() && (iX < this.getWidth()+this.getX()) && (iY < this.getHeight()+this.getY())
      	))  
      {   //wenn ((ich keine Hhe und keine Breite habe) ODER (sich der gesuchte Punkt in meinem Rechteck befindet) 
       	  //dann bin mglicherweise ich, oder eine meiner Unterseiten die gesuchte Seite
       	  
       	  if (this.getWidth()!=0 && this.getHeight()!=0) {
       	    //wenn ich eine Hhe und eine Breite habe (also wenn ich in der Karte dargestellt werde und sich der gesuchte Punkt in meinem Rechteck befindet)
       	    searchedProduct = this; //dann bin ich mglicherweise die gesuchte Seite-> oder noch konkreter eine meiner Unterseiten
          } //anderenfalls kann ich auf keinen Fall die gesuchte Seite sein (searchedProduct bleibt null)-> es knnte aber eine meiner Unterseiten sein.
 	      	    
 	      for (var i = 0; i < this.elements.length; i++) {
 	        //prfe, ob eine meiner Unterseiten noch besser passt
 	        var myDummyObject =	this.elements[i].getProductOnPosition(iX- this.getX(), iY - this.getY(), fZoom);
	        if (myDummyObject != null) {
	           //es wurde eine Unterseite gefunden, die besser passt:
	           //alert("myDummyObject: " + myDummyObject.getId() +", " + myDummyObject.getName());
	           return myDummyObject; //brich die Suche ab und gib die erste passende Unterseite zurck
	        }
	      };
	  };
      return searchedProduct; 
    },
    
    /**
    * paint
    * Paints the object. The order of projection are from lowest to highest:
    * <ol><li>saved SVG-Content</li><li>saved picture</li><li>Text</li></ol>
    *
    */
    paint: function() {
      
      this.oLogger.debug("Product.paint - create group");
      
      return this.myNode; 
    },

/*
   // @deprecated
    generateAutomatedMap: function() {
      try {
          var alreadySet = new Array();
          var luckyLooser = new Array();
          var actX = 0;
          var actY = 0;
          var volume = 0;
          
          for (var i=0; i < this.elements.length; i++)
            this.elements[i].calculateSize();
          
          this.elements.each(function(s) {
            volume += s.getWidth()*s.getHeight();
          });      
          
          volume = volume*1.4;
          
          this.setWidth(Math.round(Math.sqrt(volume)));
          this.setHeight(Math.round(Math.sqrt(volume)));
          this.oLogger.debug("volume:"+volume+"x:"+this.getWidth()+"y:"+this.getHeight() );
          luckyLooser = this.elements.sortBy(function(s) { return (-1)*(s.getWidth()*10+s.getHeight()); });
          
          for (var i=0; i < luckyLooser.length; i++)
            this.oLogger.debug("luckyLooser["+i+"]("+luckyLooser[i]+"): ("+luckyLooser[i].getWidth()+","+luckyLooser[i].getHeight()+")");
          
          luckyLooser[0].setX(0);
          luckyLooser[0].setY(0);        
          alreadySet.push(luckyLooser[0]);
          luckyLooser.splice(0,1);
          var change = true;
  
          while (luckyLooser.length > 0) {
            this.oLogger.warn("luckyLooser["+luckyLooser.length+"] enthlt ["
              +luckyLooser.each(function(s){return s.getId();})+"]");
            
            alreadySet.sortBy(function(s) {return (-1)*(s.getWidth()*10+s.getHeight());});
            change = false;         
           
            for (var j = 0; j < alreadySet.length; j++) {
              actX = alreadySet[j].getX()+alreadySet[j].getWidth()+1;
              actY = alreadySet[j].getY();
              
              for (var i = 0; i<luckyLooser.length; i++) {    
                width = luckyLooser[i].getWidth();
                height = luckyLooser[i].getHeight();              
               
                if ( (this.getWidth() - actX) < width
                 || (this.getHeight() - actY) < height )
                  continue;
                
                var aSX = alreadySet.detect(
                  function(s) {return (s.touchX(actX, actX+width)&&s.touchY(actY, actY+height))==true;}
                );
                
                if (aSX != null) {
                  this.oLogger.debug(luckyLooser[i]+"kollidiert mit "+aSX );
                  actY = aSX.getY()+aSX.getHeight()+1;
                  aSX = alreadySet.detect(
                    function(s) {return (s.touchX(actX, actX+width)&&s.touchY(actY, actY+height))==true;}
                  );              
                
                }
                else {
                  var str = "";
                  for (var xy=0; xy < alreadySet.length; xy++)
                    str += "\n"+alreadySet[xy]+"("+alreadySet[xy].getX()+","+alreadySet[xy].getY()+","
                            +Number(alreadySet[xy].getX()+alreadySet[xy].getWidth())+","+Number(alreadySet[xy].getY()+alreadySet[xy].getHeight())
                            +")";
                  this.oLogger.debug(luckyLooser[i]+"("+actX+","+actY+","
                      +Number(luckyLooser[i].getWidth()+actX)+","+Number(actY+luckyLooser[i].getHeight())+")"+
                      " laeuft durch:"+str);
                }
                            
                if ( (this.getWidth() - actX) >= width
                 && (this.getHeight() - actY) >= height
                 && aSX == null
                 && (luckyLooser[i].getHeight()+actY) <= (alreadySet[j].getY()+alreadySet[j].getHeight()+1)
                 ) {
                  change = true;
                  luckyLooser[i].setX(actX);
                  luckyLooser[i].setY(actY);
                  this.oLogger.info(luckyLooser[i]+"->luckyLooser["+i+"]("+actX+","+actY+","
                      +Number(luckyLooser[i].getWidth()+actX)+","+Number(luckyLooser[i].getHeight()+actY)+")"
                      +" passt an "+alreadySet[j]+"->alreadySet["+j+"]("+alreadySet[j].getX()+","+alreadySet[j].getY()+","
                      +Number(alreadySet[j].getWidth()+alreadySet[j].getX())+","+Number(alreadySet[j].getY()+alreadySet[j].getHeight())+")");
                  actX = actX + luckyLooser[i].getWidth();        
                  alreadySet.push(luckyLooser[i]);
                  luckyLooser.splice(i,1);
                  i--;
                }
              }      
            }
            
            if (!change) {
              luckyLooser[0].setX(0);
              luckyLooser[0].setY(alreadySet.max(function(s) { return (s.getHeight()+s.getY());}));
              this.oLogger.info("no change, luckyLooser:"+luckyLooser[0].getId()+"("+luckyLooser[0].getY()+")" );
              alreadySet.push(luckyLooser[0]);
              luckyLooser.splice(0,1);
            }
           
           for (var x=0; x < alreadySet.length;x++) {
                    this.oLogger.debug("alreadySet["+x+"]:"
                    +alreadySet[x].getId()+"("
                    +alreadySet[x].getX()+","
                    +alreadySet[x].getY()+") ["
                    +alreadySet[x].getWidth()+","
                    +alreadySet[x].getHeight()+"]"
                    );  
            }
          }
        this.setWidth(this.elements.max(function(s){return s.getX()+s.getWidth();})+(2*this.__XOFFSET__));
        this.setHeight(this.elements.max(function(s){return s.getY()+s.getHeight();})+(2*this.__YOFFSET__));        
        this.elements = alreadySet;
      } catch (e) {
          oLogger.warn("calculateSize:"+e);
      }    
    },
*/

}

Object.extend(Product.prototype, Enumerable);
