/**
 * Holds the Text-Collection!
 * 
 * Der View stellt die Daten des Models am Bildschirm dar. Er ermglicht
 * also die Sicht auf das Model und reagiert auf nderungen im Model.  
 *
 * @author lray
 * @company T-Systems MMS 
 * @version 2007-03-28   
 */  

  var TextBoxView = Class.create();

  TextBoxView.prototype = {
    oVTnTChatInput: Object(),

    oLogger:Object(),

    oModel: Object(),
    oView: Object(),
    oController: Object(),
    sName: String(),

     
    initialize: function(oModel, sName) {
      
      this.oLogger = new Log4js.getLogger("vtntTest");
      this.oLogger.debug("TextBoxView initiated");

      this.sName = sName;
      this.oModel = oModel;
      this.oModel.addObserver(this);
      this.generateSource();

    },
    
    /**
     * setzt den Controller, welcher eingebettet werden soll.
     * TODO: evtl. mehrere Controller einbetten? Anordnung?
     * 
     * @ version 2007-03-28
     * @author lray
     */                             
    setController: function(item) {
      this.oController = item;
      this.oVTnTChatInput.appendChild(this.oController.paint());     
    },

    /**
     * setView
     * setzt den View, welcher eingebettet werden soll.
     * TODO: evtl. mehrere Controller einbetten? Anordnung?
     * 
     * @param Object View - einzubettender View
     * @version 2007-03-28
     * @author lray
     */
    setView: function(item) {
      this.oView = item;
      this.oVTnTChatInput.appendChild(this.oView.paint());
      try {this.oView.setParent(this);} 
        catch (e) { this.oLogger.info("textboxview.setView: konnte box "+
                      "nicht als parent beim view melden") };

    },


    /**
     * Ueberschreiben der Interfacemethode update des
     * Observer, legt die Reaktion auf Aenderungen fest.
     * @param m Modell, welches Aenderungen meldet
     * @param o Art der nderung (derzeit Array von Strings)
     */
    notify: function( m, o)
    {
      if( this.oModel == m ) { 
        if (!isNaN(parseInt(o.viewMode)) ) {
            this.oLogger.debug("VisualMap.notify: viewMode "+o.viewMode+"("+typeof(o.viewMode)+")");
            this.setViewMode(o.viewMode);
        }
        else oLogger.debug("AvatarCollection.notify: no new data (Object "+typeof(o)+") ist Array? "+ (o instanceof Array));      

      }     
    },

    update: function() {
      this.oLogger.debug("TextLineCollection.update");
//       try {

        var newElements = this.oModel.getTextLineData();
        this.elements = Array();
        for (var i =0; i < newElements.length; i++) {
          if (newElements[i] instanceof TextLine) {
            var tmpElements = new TextLineDecorator(newElements[i]);
            tmpElements.setSIdUserName(this.oModel.getUserById(newElements[i].getSId()).getName());
            this.oLogger.debug("TextLineCollection.update: pushing "+tmpElements);
            this.add(tmpElements);
          } else {
              this.oLogger.debug("TextLineCollection.update: new element not a Textline ("+typeof(newElements[i])+")");
          }
        }
//       } catch (e) { alert("AvatarCollection.updateUser catched: "+e);}
    },

    
    _each: function(iterator) {
        for ( var i = 0; i < this.elements.length; i++)
          iterator(this.elements[i]);
    },   
    
    /**
     *setLines2Show
     *hlt die information, wie viele Text-Eintrge durch
     *"paint" zurckgegeben werden.
     *
     *@param Number - Zeilenanzahl
     *@version 2007-02-15   
     *@author lray       
     */                             
    setLines2Show: function(item) {
      this.iLines2Show = item;
      this.oLogger.info("TextLineCollection.setLines2Show:"+item);
    },

  /**
   *setAttribute
   *   
   * setzt Attribute des html-baums
   *
   * @version 2007-03-28
   * @author lray
   */                
    setAttribute: function(key, value) {
      this.oVTnTChatInput.setAttribute(key,value);
    },
    
    /**
     * setViewMode
     * 
     * stellt die ViewBox den verschiedenen Modi entsprechend dar.
     * 
     * @version 2007-03-29
     */
     setViewMode: function(item) {
      switch (item ) {
      case 0: this.setAttribute("class","minimized and_closed");             
              break;
      case 1: this.oVTnTChatInput.removeAttribute("class");
              break;
      default: ;
      }
     },                            
 
    /**
     *paint
     *
     * stelle einen xhtml-Konformen DOM zusammen und liefert diesen aus.
     * @return DOM
     * @version 2007-02-15
     * @author lray            
     */             
    paint: function() {
      return this.oVTnTChatInput;
    },
    

    generateSource: function() {
      this.oVTnTChatInput = document.createElement('div');
      this.oVTnTChatInput.setAttribute('id','vTnTChat')
    },

    toString: function() {
      return this.sName;
    }
  }
