/**
 * Textline-Objekt
 * 
 * haelt die zu einem Text-Eintrag gehoerenden Eigenschaften.
 * 
 * @author lray
 * @version 2007-02-15
 */      

  var TextLineDecorator = Class.create();
  TextLineDecorator.prototype = {
  	oNewTextLine:Object(),
    
    oLogger:Object(),   
    iTextLength : Number(-1),
    oNewTextLineTextText: Object(),
    oNewTextLineNickText: Object(),
    oNewTextLineImage: Object(),
    oNewTextLineIdText: Object(),
    oNewTextLineText: Object(),
    bEffect: Boolean(false),
    sName: String("Instance of TextLineDecorator"),

    oTextLine: Object(),

    initialize: function(oTextLine) {
      //open maingroup
      this.oLogger = new Log4js.getLogger("vtntTest");
      this.oLogger.debug("single TestLine initiated");
    
      this.oNewTextLine = document.createElementNS(xhtmlNS,'div');
   	  this.oNewTextLine.setAttribute('class',"ava_thread distance_1"); 

      var oNewTextLineNick = document.createElementNS(xhtmlNS,'span');
      this.oNewTextLineNickText = document.createTextNode("hallo");
      oNewTextLineNick.setAttribute('class','ava_nick');
      oNewTextLineNick.appendChild(this.oNewTextLineNickText);
      
      this.oNewTextLineImage = document.createElementNS(xhtmlNS,'img');
      this.oNewTextLineImage.setAttribute("width","37");
      this.oNewTextLineImage.setAttribute("height","37");
      /*this.oNewTextLineImage.setAttribute("src",
        this.oModel.getUserById(this.oNewTextLineIdText.getPicUrl())
      );
      oNewTextLineNick.appendChild(this.oNewTextLineImage);*/

      var oNewTextLineId = document.createElementNS(xhtmlNS,'span');
      oNewTextLineId.setAttribute('class','ava_id');
      this.oNewTextLineIdText = document.createTextNode("");
      oNewTextLineId.appendChild(this.oNewTextLineIdText);

      this.oNewTextLineText = document.createElementNS(xhtmlNS,'span');
      this.oNewTextLineText.setAttribute('class','ava_text');
      this.oNewTextLineTextText = document.createTextNode("");
      this.oNewTextLineText.appendChild(this.oNewTextLineTextText);

      this.oNewTextLine.appendChild(oNewTextLineNick);
      this.oNewTextLine.appendChild(oNewTextLineId);
      this.oNewTextLine.appendChild(this.oNewTextLineText); 

      if (oTextLine instanceof TextLine)
      {
        this.oTextLine = oTextLine;
        this.updateComponent();
      } else
        this.oTextLine = new TextLine();

    },

    updateComponent: function() {
      this.setId(this.getId());
      this.setSId(this.getSId());      
      this.setX(this.getX());
      this.setY(this.getY());
      this.setTimestamp(this.getTimestamp());
      this.setText(this.getText());
      this.setLoudness(this.getLoudness());
      this.setCircle();      
    },


    notify: function() {
      this.oLogger.warn("TextLine-Class "+this.getId()+" notified, but not yet implemented.");
    },

    remove: function() {

    },

  	setX: function(xpos) { 
      this.oTextLine.setX(xpos);
    },
  
  	getX: function() { return this.oTextLine.getX();},

  	setY: function(ypos) {
      this.oTextLine.setY(ypos);
    },
  	getY: function() {return this.oTextLine.getY();},

    /**
     *getDistance
     *gibt die direkte Entfernung zwischen einem Punkt und der eigenen aktuellen Position zurck.
     *
     * @param  Number Abszisse des Punktes
     * @param  Number Ordinate des Punktes
     * @author lray
     * @version 2007-02-15
     */                                            
    getDistance: function() {
      return this.oTextLine.getDistance();
    },

    setDistance: function (xpos, ypos) {
          this.oTextLine.setDistance(xpos, ypos);
          this.setCircle();
    },

    setCircle: function () {
          var iMyLoudness = this.getLoudness();
          if (isNaN(iMyLoudness) || iMyLoudness < 1) iMyLoudness = 1;
          this.oNewTextLineText.setAttribute('class','ava_text distance_'
                +Math.round(
                  (this.getDistance()/iMyLoudness)*10
                )
          );         
    },

  	setId: function(id) {
      this.oTextLine.setId(id);
      this.oNewTextLine.setAttribute('id',this.getId()+"avaThread");
    },
  	getId: function() {return this.oTextLine.getId();},
  
  	setSId: function(id) {
      this.oTextLine.setSId(id);
      
    },
  	getSId: function() {return this.oTextLine.getSId();},

    setSIdUserName: function(item) {
      this.oNewTextLineNickText.data =item+"("+this.getSId()+"):";
      this.updateView();
      //this.oNewTextLineNickText = document.createTextNode(item);
    },

    setPicture: function(picUrl) {
          this.oNewTextLineImage.setAttribute("src",picUrl);
    },

  	setTextLength: function(item) { 
      this.iTextLength = item;
      this.updateView();
    },
  	getTextLength: function() { return this.iTextLength;},


    setTimestamp: function(item) {
      this.oTextLine.setTimestamp(item);

      if (this.bEffect == true) {
        this.bEffect=false;
        this.clearScope('tlFade'+this.getId());
        try {
        	new Effect.Fade( this.oNewTextLine, {
        		 duration: 150.0,
        		 from: 1.0,
        		 to: 0.0,
        		 queue: { 
        			position:'end',
        			scope: 'tlFade'+this.getId(),
        			limit:1
        		 },
     		     //afterFinish: obj_removeTextLine,
  	      }); 	
  	    } catch (e) { }
      } //If
    },
    getTimestamp: function() {return this.oTextLine.getTimestamp();},
     
    setText: function(item) {
      this.oTextLine.setText(item);
    },
  	getText: function() {return this.oTextLine.getText();},

    setLoudness: function(item) {
      this.oTextLine.setLoudness(item);
    },
  	getLoudness: function() {return this.oTextLine.getLoudness();},

    clearScope: function(name) {
    	var queue = Effect.Queues.get(name);
	    queue.each(function(e) { e.cancel() });
    },

    /**
     * updateView
     * synchronisiert den internen Datenstand mit dem xhtml-konformen DOM
     * 
     *@author lray
     *@version 2007-02-15
     */                             
    updateView: function() {
      if (this.getTextLength()!= -1 && this.getText().length > this.getTextLength())
        this.oNewTextLineTextText.data = this.getText().substring(0,(this.getTextLength()-3))+"...";
      else
        this.oNewTextLineTextText.data = this.getText();  
      
    },

    paint: function() {      
      return this.oNewTextLine;
    },
 
    toString: function() {
      return this.sName;
    }
}
