/**
 * Holds the Text-Collection!
 *
 * @author lray
 * @company T-Systems MMS 
 * @version 2007-03-28   
 */  

  var TextLineView = Class.create();

  TextLineView.prototype = {
    elements: Array(),
    aNameFilter: Array(),
    oTextLineCollection: Object(),
    oLogger:Object(),
    iLines2Show : Number(15),
    iTextLength : Number(-1),
    iTimestamp: Number(0),
    iPreTimestamp: Number(0),
    iTimeStampNewestMessage: Number(0),  
    oModel: Object(),
    oParent: Object(),
    sName: String(),
    oUser2TalkFor: Object(),
     
    initialize: function(oModel, sName, oUser) {
      
      this.oLogger = new Log4js.getLogger("vtntTest");
      this.elements = new Array();
      this.oLogger.debug("TextLineCollection initiated");

      try {
        //this.setTimestamp(Number(new Date().getTime()));
        //this.setTimestampNewestMessage(Number(new Date().getTime()));
        
        this.setTimestamp(Number(0));
        this.setTimestampNewestMessage(Number(0));
      } catch (e) {this.oLogger.info("textLineView.init: "+e);};

      this.oTextLineCollection = document.createElementNS(xhtmlNS,'div');
      this.oTextLineCollection.setAttribute('id','vTnTChatOutput');
      
      if (! oModel instanceof vTnTModel) {   
        this.oLogger.warn("TextLineCollection: kein Modell angegeben, vTnT laeuft im Leerlauf!");
      } else {

        this.oLogger.debug(this.toString()+" initiated");
        this.oModel = oModel;
        this.oModel.addObserver(this);      
      }

      if ( oUser instanceof User) this.User2TalkFor = oUser;
      else this.oLogger.warn("TextLineCollection.initialize: kein Referenz-User uebergeben")

    },
    
/**
 * function addTextLine
 * 
 * creates a new TextLine-Object and adds it into the Collection. 
 * This is done only, when the textLine-ID is not already within the collection,
 * to prevent duplicates.
 * 
 * @param String id ID of TextLine
 * @param String sid ID of User
 * @param Number xpos X-Position of the text being spoken
 * @param Number ypos Y-Position of the text being spoken
 * @param String text The Text itself
 * @param Date timestamp Timestamp of the text.
 * @author lray
 * @version 2007-02-15
 */       
    addTextLine: function(id, sid, xpos, ypos, text, timestamp) {
         
         if (this.detect( function(value) {
                return value.getId();
            })!= false) {
           var myTextLine = new TextLine();
           myTextLine.setX(xpos);
           myTextLine.setY(ypos);
           myTextLine.setSId(sid),
           myTextLine.setId(id);
           myTextLine.setText(text);
           try { myTextLine.setTimestamp(timestamp); } catch (e) {this.oLogger.info("textLineview.addTextLine:"+e);};
           this.add(myTextLine);
          this.oLogger.debug("added TextLine.");
        }
     },

    /** 
     * function add
     *
     * adds a new TextLine to the collection          
     * on every Add of a new Textline, we have to delete the whole plot and bring it in sorted...
     *    
     * @param TextLine item - Object holding an instance of TextLine
     * @version 2007-02-15
     * @author lray          
     */
    add: function (item) {
      this.elements.push(item);
      // deletes duplicate entries
      this.elements = this.elements.uniq();
      //this.updateView();
    }, 

     /**
     * Ueberschreiben der Interfacemethode update des
     * Observer, legt die Reaktion auf Aenderungen fest.
     * @param m Modell, welches Aenderungen meldet
     * @param o Art der nderung (derzeit Array von Strings)
     */
    notify: function( m, o)
    {
      if( this.oModel == m) { 
        var updateView = Boolean(false);
        if ((o.textline instanceof Array) && (o.textline.length > 0)) {
            this.update(o.textline);
        	updateView = true;
        };
        if (m.getTextTimestamp() > this.getTimestamp())
        	this.setTimestamp(m.getTextTimestamp());
        
        try{
        	if ( o.textlineconfig.lines2show) {
            	 this.setLines2Show(o.textlineconfig.lines2show);
            	updateView = true;
            }
        } catch (e) {}
        
        try {
          switch (o.viewMode) {
          case 0: this.setLines2Show(1);
                  this.setTextLength(35);
                  this.setNameFilter(new Array(String(this.oModel.getOwnUser()[0].getId())));
                  if (this.getTimestamp() <= this.getTimestampNewestMessage())
                      this.setTimestamp(this.getTimestampNewestMessage()+1);
                  //alert("newTextLine viewMode updated");
                  updateView = true;
                  break;
                  
          case 1: this.setLines2Show(150);
                  this.setTextLength(-1);
                  this.setNameFilter(new Array());
                  this.setTimestamp(0);
                  updateView = true;
                  break;
          default: break;
          }
        } catch (e) {};
        if (updateView == true) {
        	try { this.updateView();} catch (e) {this.oLogger.debug("TextLineView.notify: update failed:"+e)}
        }
      }     
    },


    /**
     * setParent
     * 
     * hlt das Elternobjekt. Dies mu bearbeitet werden, wenn ber den Control-
     * ler ein Fenster direkt bearbeitet werden soll... beispielsweise bei Zeilen-
     * lnge null.
     * 
     * @author lray
     * @version 2007-03-28
     */                                       
    setParent: function(parent) {
      this.oParent = parent;
      this.oLogger.debug("textLineView.setParent:"+parent);
    },

    getParent: function() {
      return this.oParent;
    },

    /**
     * update
     * [will follow]
     * 
     * @author lray
     * @version 2007-03-28
     **/                                 
    update: function() {
      this.oLogger.debug("TextLineCollection.update");
//       try {
        var newElements = this.oModel.getTextLineData();
        this.elements = Array();
        for (var i =0; i < newElements.length; i++) {
          if (newElements[i] instanceof TextLine) {
            var tmpElements = new TextLineDecorator(newElements[i]);
            try {
              tmpElements.setSIdUserName(this.oModel.getUserById(newElements[i].getSId()).getName());
            } catch (e) {
              this.oLogger.warn("Fehler: "+e+" Element "+newElements[i]+"Type :"+typeof newElements[i]+" SID:"+newElements[i].getSId());
              continue; //ignoriere aktuelle nachricht
            }
            this.oLogger.debug("TextLineCollection.update: pushing "+tmpElements);
            this.add(tmpElements);
          } else {
              this.oLogger.debug("TextLineCollection.update: new element not a Textline ("+typeof(newElements[i])+")");
          }
        }
//       } catch (e) { alert("AvatarCollection.updateUser catched: "+e);}
    },

    
    _each: function(iterator) {
        for ( var i = 0; i < this.elements.length; i++)
          iterator(this.elements[i]);
    },   
    
    /**
     *setLines2Show
     *hlt die information, wie viele Text-Eintrge durch
     *"paint" zurckgegeben werden.
     *
     *@param Number - Zeilenanzahl
     *@version 2007-02-15   
     *@author lray       
     */                             
    setLines2Show: function(item) {
      this.iLines2Show = item;
      this.oLogger.info("TextLineCollection.setLines2Show:"+item);
    },

    /**
     *getLines2Show
     *liefert die Anzahl der durch "paitn" zu liefernden Text-Eintrge
     *
     *@return Number - Zeilenanzahl
     *@version 2007-02-15   
     *@author lray       
     */                             
    getLines2Show: function() {
      return this.iLines2Show;
    },

    /**
     *setLineLength
     * setzt die Zeichenanzahl, welche eine TextLinie bei Ausgabe ber
     * "paint" maximal besitzen darf.
     * @param Number Zeichenanzahl
     * @version 2007-02-15
     * @author lray
     */                               
    setTextLength: function(item) {
      this.iTextLength = item;
    },

    /**
     *getTextLength
     * liefert die Zeichenanzahl, welche eine TextLinie bei Ausgabe ber
     * "paint" maximal besitzen darf.
     * @result Number Zeichenanzahl
     * @version 2007-02-15
     * @author lray
     */                               
    getTextLength: function() {
      return this.iTextLength;
    },

    /**
     * setNameFilter
     * Filtert Textnachrichten der UIDs bei der nutzung von "paint" aus dem
     * Ergebnis heraus.
     * 
     * @param Array - Liste der UIDs
     * @author lray
     * @version 2007-02-15
     */                                        
    setNameFilter: function (aName) {
      this.aNameFilter = aName;
      this.oLogger.info("TextLineCollection.setLNameFilter:"+this.aNameFilter.join(","));
    },
    
    /**
     * getNameFilter
     * gibt die Liste der UIDs, deren Textnachrichten bei der Nutzung von "paint" aus dem
     * Ergebnis herausgefiltert werden.
     * 
     * @result Array - Liste der UIDs
     * @author lray
     * @version 2007-02-15
     */                                        
    getNameFilter: function() {
      return this.aNameFilter;
    },
    
    /**
     * setTimestamp
     * Filtert Textnachrichten , die lter als der gegebene Timestamp sind.
     * 
     * @param Date - Timestamp
     * @author lray
     * @version 2007-02-15
     */                                        
    setTimestamp: function (item) {
      if (item instanceof Date) {
        item = Number(item.getTime());
      } else {
        item = Number(item);
      }
      this.iTimestamp = item;
      //this.updateView();
    },
    
    /**
     * getTimestamp
     * gibt den Timestamp, ab dem bestimmte Nachrichten durch "paint" zurckge-
     * liefert werden.
     * 
     * @result Date - Timestamp
     * @author lray
     * @version 2007-02-15
     */                                        
    getTimestamp: function() {
      return this.iTimestamp;
    },      
    
    /**
     * setTimestampNewestMessage
     * hlt den Timestamp der neusten Nachricht
     * 
     * @param Date - Timestamp
     * @author lray
     * @version 2007-02-15
     */                                        
    setTimestampNewestMessage: function (item) {
      if (item instanceof Date) {
        this.iTimestampNewestMessage = Number(item.getTime());

      } else 
        this.iTimestampNewestMessage = Number(item);
    },
    
    /**
     * getTimestamp
     * gibt den Timestamp der neusten Nachricht
     * 
     * @result Date - Timestamp
     * @author lray
     * @version 2007-02-15
     */                                        
    getTimestampNewestMessage: function() {
      return this.iTimestampNewestMessage;
    },  

 
	updateNewestMessageToActualTimestampIfNewer: function(element) {
 	   if (element.getTimestamp() > this.getTimestampNewestMessage()) {
            try {
              this.setTimestampNewestMessage(element.getTimestamp());
              this.oLogger.debug("got new Timestamp:"+element.getTimestamp()+ " - "+this.getTimestampNewestMessage());
            } catch (e) {this.oLogger.info("textLineView.updateNewestMessageToActualTimestampIfNewer:"+e);};
          }
 	},
 	
     /**
     * updateView
     * synchronisiert internen Datenbestand und xhtml-Darstellung
     *
     * @return Number - Anzahl der ausgebbaren TextLines.      
     * @author lray
     * @version 2007-02-15
     */                             
    updateView: function() {
      var oToBeDeleted;
      var i;
      var j = 0;

      // lscht gesamten Messageverlauf
      while (oToBeDeleted = this.oTextLineCollection.firstChild)
        this.oTextLineCollection.removeChild(oToBeDeleted);
      
      this.elements = this.elements.uniq();
      
      // sortiert alle TextLines nach Timestamp
      this.sortBy(function(value) { return value.getTimestamp(); });    
          
      //if (this.oLogger.isDebugEnabled())
        this.oLogger.warn(
            "textLineview.updateView: "+
            "aktueller Timestamp:"+this.getTimestamp()
            +" lastMessageTimestamp: "+this.getTimestampNewestMessage()
            +"Name-Filter"+this.getNameFilter()
            +"getLines2Show"+this.getLines2Show());
      
      //fgt aktuelle Nachrichten ein
      if (!this.oModel.isIgnoreTextLines()) { 
	      for (i = (this.elements.length -1); i >= 0; i--) {      
	        
	        // aktuelle Nachricht wird nicht vom Filter gestoppt und ist neuer als der interne Timestamp
	        if ((this.getNameFilter().length == 0 || this.elements[i].getSId()!= (this.getNameFilter())[0])
	            //&& (this.getTimestamp() instanceof Number)
	            &&( this.elements[i].getTimestamp() >= this.getTimestamp() ) )
	        {
	          
	          this.updateNewestMessageToActualTimestampIfNewer(this.elements[i]);
	
	          this.elements[i].setTextLength(this.getTextLength());
	          this.oTextLineCollection.appendChild(this.elements[i].paint());    
	          
	          j++;
	        } else 
	          if (this.elements[i].getSId()== this.getNameFilter()[0]) {
	          	this.oLogger.debug("TextCollection: Nachricht "+this.elements[i].getId()+" von "+this.elements[i].getSId()+" in ("+this.aNameFilter.join(", ")+") enthalten, gefilter.");
	            j++;
	          }
	          else
	           	this.oLogger.warn("TextCollection: Nachricht "+this.elements[i].getId()+" vom "+this.elements[i].getTimestamp()+" lter als "+this.getTimestamp()+", gefilter.");
	        
	        if (j >= this.getLines2Show()) break;         
	      }   
	
	    /* if (this.getLines2Show() == 1) {
	     	alert(j+"  "+String(this.elements[i].getSId())+" - "+String(this.getNameFilter()[0]));
	     }*/
	     
	     if ((this.getLines2Show() == 1) && j==1) {
	     
	     	if (String(this.elements[i].getSId()) == String(this.getNameFilter()[0])) {
	       		this.oLogger.debug("TextLineView.udpateView: minimized and closed");
	    	    this.oParent.setAttribute("class","minimized and_closed");
	    	  } else  {
				this.oLogger.debug("TextLineView.udpateView: minimized ->"+j+"  "+String(this.elements[i].getSId())+" - "+String(this.getNameFilter()[0]));       
				this.oParent.setAttribute("class","minimized");
	    	  }
	   
	      }
      }
      //alert("updateView - "+j);     
      return j;
    },

    /**
     *paint
     * stelle einen xhtml-Konformen DOM zusammen und liefert diesen aus.
     * @return DOM
     * @version 2007-02-15
     * @author lray            
     */             
    paint: function() {
      return this.oTextLineCollection;
    },
    
    toString: function() {
      return this.sName;
    }
  }

  Object.extend(TextLineView.prototype, Enumerable);

