/**
 * Class Modell
 * 
 * Das Modell enthlt die Daten und Kernfunktionalitt der Anwendung, ist
 * unabhngig vom View und Controller und hat insbesondere noch folgende
 * zustzliche Aufgaben: 
 * 
 * Das Model kennt alle View und Controller, die zum Einsatz kommen, und 
 * informiert diese ber nderung in den Anwenderdaten.
 * 
 * Es hlt die Ajax-Verbindung mit der Serverseite und pollt diese regelmaessig
 * nach Vernderungen.   
 * 
 * @author lray
 * @version 2007-02-20
 */
 //  copyPrototype(myTest, myTest2);
// my second OO-JavaScript

  var vTnTModel = Class.create();
  
  vTnTModel.prototype = {
      oLogger: Object(),
      sName: String("vTnTModel"),
      aChanged: Array(),
      oProducts: Object(),
      aUser: Array(),
      aUser2Update: Array(),
      aTextLine: Array(),
      iUTimestamp: Number(0),
      iTextTimestamp: Number(0),
      iLastTextMessage: Number(0),
      sPrefixId: String(),
	  iPageId: Number(0),

/*      oDetailedUser: Object(),*/

      // Details of Area being around
      iZoomLevel: Number(1),
      iTranslationX: Number(0),
      iTranslationY: Number(0),      
      iWidth: Number(0),
      iHeight: Number(0),
      oTextPosition: Object(),
      oObjects2BeNotifiedFor: Object(),
      iViewMode: Number(0),

      // for TextView
      iTextLines2Show: Number(15),
      iTextLength: Number(65),
      aNameFilter: Array(),
      bIgnoreTextLines: Boolean(false),
      
      initialize:function() {
        this.oLogger = new Log4js.getLogger("vtntTest");
        //this.elements = $A(arguments);
        this.sName = "vTnTModel";
        this.oProducts = new Product();
        
        this.oObjects2BeNotifiedFor["user"] = new Array();
        this.oObjects2BeNotifiedFor["textline"] = new Array();
        this.oObjects2BeNotifiedFor["userid"] = new Array();
        this.oObjects2BeNotifiedFor["viewMode"] = this.iViewMode;
        this.oObjects2BeNotifiedFor["zoomLevel"] = this.iZoomLevel;
        this.oObjects2BeNotifiedFor["detailedUser"] = null;        
        this.oObjects2BeNotifiedFor["detailedProduct"] = null;        
        this.oTextPosition.date = 0;
      },

    _each: function(iterator) {
        for ( var i = 0; i < this.aUser.length; i++)
          iterator(this.aUser[i]);
    },

	/**
	* legt die aktuelle pageId fest
	*/
	setPageId: function(id) {
		this.iPageId = id;
	},

	getPageId: function() {
		return this.iPageId;
	},

    /**
    * o sendet jeden Nutzer, welcher sich aktualisiert, an den Server 
    * o 
    */
    getUserDataFromServer: function() {
      this.aUser2Update = this.aUser2Update.uniq();
      //this.oLogger.debug("vtntModel.getUserDataFromServer: updating "
      //        +this.aUser2Update.join(","));
      
      oLogger.info("vtntModel.getUserDataFromServer: updating "
              +this.aUser2Update.join(","));


      for (var i=0; i < this.aUser2Update.length; i++) {
        this.sendUserToServer(this.getUserById(this.aUser2Update[i]));
        //this.oLogger.debug
        oLogger.info("vtntModel.getUserDataFromServer:"
                +" Sending to vtntModel.sendUserToServer:"
                +this.getUserById(this.aUser2Update[i]));
      };
          
      if (this.getOwnUser()[0]) {       
         oLogger.debug(this.getUTimestamp()+" -> "+this.getOwnUser()[0].getId());
         getUserData(this, this.getUTimestamp(), this.getOwnUser()[0].getId());
         
        this.userCleanUp();      
      }  
      else
   		getPing(this,this.getTimestamp());

      this.aUser2Update = new Array();
    },

    /**
     * Entfernt Nutzer, welche die Penalty ueberschritten hat
     * 
     * @author lray
     * @version 2007-02-27
     */
     userCleanUp: function() {
        for (var i=(this.aUser.length - 1); i>0 ; --i) {
          if ((this.aUser[i] instanceof User)
              && this.aUser[i].getLastSeen() < (this.getUTimestamp() - 200)
              && !this.aUser[i].isOwn()) {
            //this.tmp = this.aUser.clone();
            this.aUser.splice(i,1);
            //this.oLogger.warn(this.tmp.join(",")+" entferne element "+i+" \n und erhalte "+this.aUser);
          }          
        }
     },                              
    
    /**
     *  Gibt Wortzeilen seit der letzten Aktualisierung an dieser Stelle zurck.
     *  Dabei werden Wortmeldungen benoetigt, deren Loudness in die Koordinaten
     *  faellt. Also bei Abfrage von (10,20) eine Nachricht mit (x,y)=(2,20) und
     *  Loudness=8          
     *  
     *  @author  lray
     *  @version 2007-02-22               
     */         
    getTextDataFromServer: function() {
      var movingDate = this.getTextPosition().date;
      
      if (this.iTextTimestamp == 0 && this.iUTimestamp != 0)
        this.iTextTimestamp = this.iUTimestamp;
      
      /*if (movingDate < this.iTextTimestamp)  
        movingDate = this.iTextTimestamp;*/
      updateChat(this, this.getTextPosition().x,this.getTextPosition().y, movingDate, this.iLastTextMessage);
    },

    sendTextLineToServer: function(oTextLine) {
      ajaxSetTextLine(      this,
                        oTextLine.getId(),
                        oTextLine.getSId(),
                        oTextLine.getX(),
                        oTextLine.getY(),
                        oTextLine.getLoudness(),
                        oTextLine.getText()
      );
    },
    

    /**
    * getProductsFromServer
    *
    * uebertraegt alle Produkte innerhalb des ausgeschnittenen Fensters.
    * @TODO implement
    * @param xmin Number 
    * @param xmax Number
    * @param ymin Number
    * @param ymax Number
    **/
    getProductsFromServer: function(xMin, yMin, xMax, yMax, zoomLevel, init) {
      var iterationen = 1;
      
/*      if (zoomLevel == null) zoomLevel = this.iZoomLevel
 
      if (zoomLevel > 1 )  iterationen = 2;
      if (zoomLevel > 1.3) iterationen = 3;
      if (zoomLevel > 1.5) iterationen = 4;
      if (zoomLevel > 1.7) iterationen = 5;
      if (zoomLevel > 2)   iterationen = 6;*/
      getProductMap( this, 1, xMin, yMin, xMax, yMax, iterationen, init);
    },
    
    /**
     * setTextPosition
     * @param xpos Number X-Position des Massepunktes
     * @param ypos Number Y-Position des Massepunktes
     * @param movingDate Date Zeitpunkt, wann der Massepunkt dahin gesetzt wurde              
     */         
    setTextPosition: function(xPos, yPos, movingDate) {
      this.oLogger.debug("vtntModel.setTextposition:"+xPos+" "+yPos+" "+movingDate);
      this.oTextPosition.x = xPos;
      this.oTextPosition.y = yPos;
      this.oTextPosition.date = movingDate;
    },
    
    getTextPosition: function() {
      return this.oTextPosition;
    },

    /**
    * pflegt Nutzer in die Server-Architektur ein.
    */
    sendUserToServer: function(oItem) {
      oLogger.info("sendUserToServer got "+oItem+" with type"+typeof oItem);
      if (oItem instanceof User || oItem instanceof Avatar) {
        ajaxSendUserToServer( this,
                  oItem.getId(), 
			        	  oItem.getNick(), 
			        	  oItem.getX(), 
			        	  oItem.getY(), 
			        	  oItem.getLoudness(), 
			        	  oItem.isActive(), 
			        	  oItem.getName(), 
			        	  oItem.getCompany(), 
			        	  oItem.getPositionName(), 
			        	  oItem.getPicUrl()
			    );

      }
      else this.oLogger.debug("vtntModel.sendUserToServer: unbekanntes oItem "+typeof(oitem));
    },

   getUserData: function(lastChange) {
      this.oLogger.debug("in getUserData with "+this.aUser.length+" Users");
      return this.aUser;
   },
   
   getUserById: function(sItem) {
     for (var i =0; i < this.aUser.length; i++){
        if (this.aUser[i].getId() == sItem) {
         this.oLogger.debug("vtntModel.getUserById: sending "+this.aUser[i].getId());
         return this.aUser[i];
         }
     }
    return false;  
   },

   getTextLineById: function(sItem) {
     for (var i =0; i < this.aTextLine.length; i++){
        if (this.aTextLine[i].getId() == sItem) {
         oLogger.debug("vtntModel.getTestlineById: returning "+this.aTextLine[i].getId()+"("+i+")");
         return this.aTextLine[i];
         }
     }
    return false;  
   },

   getTextLineData: function(lastChange) {
      this.oLogger.debug("vTnTModel.getTextLineData: "
                         +this.aTextLine.length+" Lines");
      return this.aTextLine;
   },

    /*
    * Adds a TextLine-Object into the textwindow and transmittes it to the server.
    */
    addTextLine: function(oItem, bRemote) {
 	
     	if (bRemote && oItem.getId() > this.iLastTextMessage)
            this.iLastTextMessage = oItem.getId();    
         
        oItem.setDistance(this.getTextPosition().x, this.getTextPosition().y);
        this.oLogger.info("vtntModel.addTextLine: observers will be informed about new TextLine");
    
     	if (bRemote != true)
            this.sendTextLineToServer(oItem);

      if (oItem.getDistance() <= oItem.getLoudness()) {
        this.aTextLine.push(oItem);
        if (!(this.oObjects2BeNotifiedFor["textline"] instanceof Array))
          this.oObjects2BeNotifiedFor["textline"] = new Array();
        this.oObjects2BeNotifiedFor["textline"].push(oItem.getId());
        /*this.notifyObservers(this.oObjects2BeNotifiedFor);
        this.clearNotifierCache();*/
      }

    },

    addUser: function(oItem, bRemote) {
      if (oItem instanceof User) {
        this.aUser.push(oItem);
        if (oItem.isOwn() && bRemote != true){
          this.aUser2Update.push(oItem.getId());
          } 

      } else 
          alert(
            "vtntmodel.addUser: Item is not instance of class.User"
          );
    },

    removeUser: function(iId) {
      for (var j=0; j < this.aUser.length; ++j ) {
      	if (this.aUser[j].getId().equals(oId)) {
          this.aUser.splice(j,1);break; 
        }
      }
    },

    clearNotifierCache: function() {
      var tmpDetailedUser;
      if (this.oObjects2BeNotifiedFor.detailedUser instanceof User) {
            tmpDetailedUser = this.oObjects2BeNotifiedFor.detailedUser;
      }
      this.oObjects2BeNotifiedFor = new Object();
      this.oObjects2BeNotifiedFor.user = new Array();
      this.oObjects2BeNotifiedFor.detailedUser = tmpDetailedUser;
    },

    updateUser: function(oTmpItem, bRemote) {
      // falls lokale Aenderung, dann an Server senden.      
     this.oLogger.debug("updateUser with bRemote "+bRemote);
     if (typeof bRemote=='undefined') bRemote = false;
     
      if (bRemote == false) {
        this.aUser2Update.push(oTmpItem.getId());
        //this.oLogger.debug("vtntModel.updateUser: pushed for update "+oTmpItem.getId());
       // alert("updateUser:pushed2Get onto Server:"+oTmpItem.getId());
      }
      
      if (!(this.oObjects2BeNotifiedFor["user"] instanceof Array))
          this.oObjects2BeNotifiedFor["user"] = new Array();
        this.oObjects2BeNotifiedFor["user"].push(oTmpItem.getId());
                
      if (oTmpItem.isOwn()) {
          this.setTextPosition(oTmpItem.getX(), oTmpItem.getY(), oTmpItem.getLastMoved());
      }

	// alert("update-Abgleich");
      for (var j=0; j < this.aUser.length; ++j ) {
        if (!(this.aUser[j] instanceof User|| this.aUser[j] instanceof Avatar)) {
      //    alert("vtntModel.updateUser: aUser "+j+" is no User but "+typeof(this.aUser[j])+"!");
          return ;
          }
        if (this.aUser[j].getId() == oTmpItem.getId()) {
          
          // soll verhindern, da Remote-Daten lokale Positionsaenderungen loeschen.
          if (  this.aUser[j].isOwn() == false
          		|| bRemote == false
          		|| (
          		this.aUser[j].isOwn() == true
          		&&this.aUser[j].getBlocked() == false
          		&&this.aUser2Update.indexOf(this.aUser[j].getId()) == -1)
          		)
          {
    	    
    	    this.aUser[j].setX(oTmpItem.getX());
            this.aUser[j].setY(oTmpItem.getY());
            this.aUser[j].setLoudness(oTmpItem.getLoudness());
	        }

          this.aUser[j].setNick(oTmpItem.getNick());
          this.aUser[j].setActive(oTmpItem.isActive());
          //this.aUser[j].setOwn(oTmpItem.isOwn());
          this.aUser[j].setLastAction(oTmpItem.getLastAction());
          this.aUser[j].setLastSeen(oTmpItem.getLastSeen());
          this.aUser[j].setLastMoved(oTmpItem.getLastMoved());
          this.aUser[j].setCompany(oTmpItem.getCompany());                                
          this.aUser[j].setPositionName(oTmpItem.getPositionName());
          this.aUser[j].setPicUrl(oTmpItem.getPicUrl());
          
          if (oTmpItem.isOwn()) {
          	/* this.notifyObservers(this.oObjects2BeNotifiedFor);
          	 this.clearNotifierCache();*/
          }
          return;
        }
      } 
      // only executed, if not found in For-Loop
     // alert("vtntModel.updateUser: User "+oTmpItem.getId()+" not found, create it new!"+bRemote);
      this.addUser(oTmpItem, bRemote);
      
    },
    
    setUserData: function(aItems) {
      for (var j =0; j<aItems.length; j++ ) {
        if (aItems[j].isOwn())
          this.updateUser(aItems[j]);
      }      
    },

    /**
    * liefere alle eigenen Nutzer (i.A. genau einer) zurueck
    */
    getOwnUser: function() {
      return this.aUser.findAll(function(n) { return n.isOwn(); })
    },
  
    setDetailedUser: function(sUserID) {
      this.oObjects2BeNotifiedFor["detailedUser"] =
          this.aUser.detect(
            function(value) {
                    return value.getId() == sUserID;
            }
          );
      /*this.notifyObservers(this.oObjects2BeNotifiedFor);*/
    },

    clearDetailedUser: function() {
      this.oObjects2BeNotifiedFor["detailedUser"] = null;
     /* this.notifyObservers(this.oObjects2BeNotifiedFor);*/
    },
    
    setDetailedProduct: function (sProductID) {
      tmpProduct = this.oProducts.getProduct(sProductID);
      if (tmpProduct != null) {
        this.oObjects2BeNotifiedFor["detailedProduct"] = tmpProduct;
       /* this.notifyObservers(this.oObjects2BeNotifiedFor);*/
      }
      this.oLogger.info("sProductID set with "+tmpProduct);
    },

    setUTimestamp: function(sTimestamp) {
      this.iUTimestamp = sTimestamp;
    },
    
    /**
    * getCenter returns the center-point of all own User on the Map.
    * 
    * that's usefull for centering the viewBox of the map over them, 
    * for example.
    * 
    * @author ler
    * @version 2007-03-28                         
    */           
    getCenter: function() {
      var tmp = this.getOwnUser()[0];
      return new Array(
        tmp.getX(),
        tmp.getY()
      );
    },
    
    getUTimestamp: function() {
      return this.iUTimestamp;
    },

    setTextTimestamp: function(dTimestamp) {
      this.iTextTimestamp = dTimestamp;
    },
    
    getTextTimestamp: function() {
      return this.iTextTimestamp;
    },
    
    setTextLines2Show: function(iLines) {
      this.iTextLines2Show = iLines;
      if (!(this.oObjects2BeNotifiedFor["textlineconfig"] instanceof Object))
        this.oObjects2BeNotifiedFor["textlineconfig"] = new Object();
      this.oObjects2BeNotifiedFor["textlineconfig"]["lines2show"] = iLines;              
    },

    getTextLines2Show: function() {
      return this.iTextLines2Show;      
    },

    /**
    * setViewMode set's the layout/behaviour of the whole appliation when it's either in
    * minimalized or maximum layout.
    *
    * it informs all observer with flag "viewMode" and limits the textlines to show 
    * to the user to either 15 (maxi) or 1 line (minimized)
    * 
    * @author ler
    * @version 2008-05-30                         
    */ 
    setViewMode: function(iViewMode, bMustDo) {
      if (iViewMode != this.iViewMode || bMustDo) {
        this.oObjects2BeNotifiedFor["viewMode"] = iViewMode;
       /* this.notifyObservers(this.oObjects2BeNotifiedFor);*/       
      }
      
      this.iViewMode = Number(iViewMode);
    
      switch(this.iViewMode) {
	      case 0: this.getOwnUser().each(function(item) {item.setActive(0);}); 
	              break;
	      case 1:this.getOwnUser().each(function(item) {item.setActive(1);});
	              break;
	      default:
      }
      
    },

    getViewMode: function() {
      return this.iViewMode;      
    },

    setZoomLevel: function(iZoomLevel, bMustDo) {
      if (iZoomLevel != this.iZoomLevel || bMustDo) {
        this.oObjects2BeNotifiedFor["zoomLevel"] = iZoomLevel;
       /* this.notifyObservers(this.oObjects2BeNotifiedFor);*/    
      }
      this.iZoomLevel = Number(iZoomLevel);
    },

    getZoomLevel: function() {
      return this.iZoomLevel;      
    },

    setTextLength: function(iLength) {
      this.iTextLength = iLength;
      if (!(this.oObjects2BeNotifiedFor["textlineconfig"] instanceof Object))
        this.oObjects2BeNotifiedFor["textlineconfig"] = new Object();
        this.oObjects2BeNotifiedFor["textlineconfig"]["linelength"] = iLength;              
    },

    setTranslationX: function(iTransX) {
      this.iTranslationX = iTransX;
    },
    
    getTranslationX: function() {
      return this.iTranslationX;
    },
    
    setTranslationY: function(iTransY) {
      this.iTranslationY =iTransY;
    },
    
    getTranslationY: function() {
    	return this.iTranslationY;
    },
    
    setWidth: function(iTransX) {
      this.iWidth = iTransX;
    },
    
    getWidth: function() {
      return this.iWidth;
    },
    
    setHeight: function(iTransY) {
      this.iHeight =iTransY;
    },
    
    getHeight: function() {
    	return this.iHeight;
    },

    viewPortX: function(iX){
      return Math.round((iX-this.iTranslationX)*this.getZoomLevel());
    },
    
    viewPortY: function(iY) {
      return Math.round((iY-this.iTranslationY)*this.getZoomLevel());
    },
    
    setActualPageByPositionAndZoom: function(iX, iY, fZoom) {
    	var tmpProduct = this.oProducts.getProductOnPosition(iX, iY, fZoom);
    	//Nur zum Test4
    	alert(tmpProduct.getId()+", "+tmpProduct.getName());
    	try {
    		if ( tmpProduct != null)
    			/*if (tmpProduct.getLayer()==0) this.setZoomLevel(0.75);
    			if (tmpProduct.getLayer()==1) this.setZoomLevel(1.0);
    			if (tmpProduct.getLayer()==2) this.setZoomLevel(1.3);
    			if (tmpProduct.getLayer()==3) this.setZoomLevel(1.5);
    			if (tmpProduct.getLayer()==4) this.setZoomLevel(1.8);*/
    			
    			ajaxGetPage(tmpProduct.getId());
    			//document.getElementById('iframe').src='http://localhost/index.php?id='+tmpProduct.getId();//+'&'+this.getPrefixId()+'[noModules]=1';
    	} catch (e) {alert(e);};
    },

    setNameFilter: function(aFilter) {
      this.aNameFilter = aFilter;
      if (!(this.oObjects2BeNotifiedFor["textlineconfig"] instanceof Object))
        this.oObjects2BeNotifiedFor["textlineconfig"] = new Object();
      this.oObjects2BeNotifiedFor["textlineconfig"]["names2filter"] = aFilter;              
    },

    setPrefixId: function(id) {
    	this.sPrefixId = id;
    },
    getPrefixId: function() {
    	return this.sPrefixId;
    },
    
    setProducts: function(oProducts) {
      oProducts.calculateSize();
      this.oProducts = oProducts;
    },
    
    getProducts: function() {
      return this.oProducts;
    },
    
    setIgnoreTextLines: function(item) {
    	this.bIgnoreTextLines = Boolean(item);
    	if (this.isIgnoreTextLines() == false) {
     	  cTextLineExchange = new PeriodicalExecuter( function() { myModel.getTextDataFromServer();} , 10);
    	}
    	else {
    	  cTextLineExchange.stop();
    	}
    },
    
    isIgnoreTextLines: function() {
    	return this.bIgnoreTextLines;
    },
    
    updateProducts: function() {
      // falls lokale Aenderung, dann an Server senden.      
	     this.oLogger.debug("updateProducts");   
	     this.oObjects2BeNotifiedFor["products"] = new Boolean(true);
	     /*this.notifyObservers(this.oObjects2BeNotifiedFor);
	     this.clearNotifierCache();*/
    },
    
    setLastTextMessage: function(iLastTextMessage) {
      this.iLastTextMessage = iLastTextMessage;
    }
    
  }
  
    function copyPrototype(descendant, parent) {
        var sConstructor = parent.toString();
        var aMatch = sConstructor.match( /\s*function (.*)\(/ );
        if ( aMatch != null ) { descendant.prototype[aMatch[1]] = parent; }
        for (var m in parent.prototype) {
            descendant.prototype[m] = parent.prototype[m];
        }
    };
    
    Object.extend(vTnTModel.prototype, Enumerable);
    Object.extend(vTnTModel.prototype, Observable.prototype);
//    copyPrototype(vTnTModel, Observable);
